/********************************************************************************************\
 * vsb_init_document_node_chain contains all initialization methods that are performed on the
 * document node. They are called once on page load, NOT when content is async loaded
 * Any changes to the dom (events...) must be added/performed on the document node itself, as
 * rails turbolinks will replace the whole content of the document node.
\********************************************************************************************/
vsb_init_page_load_chain = Array();

/********************************************************************************************\
 * vsb_init_content_chain contains all initialization methods for dynamically added/loaded dom nodes.
 * They are called when rails turbolinks replace the content and may also be called by arbitrary code that
 * adds/replaces/loads content that need initialization
 \********************************************************************************************/
vsb_init_dynamic_content_chain = Array();

// apply a chain to a dom_node
vsb_apply_chain = function(chain,dom_node){  for (var i = 0; i < chain.length; i++) { chain[i](dom_node); } };