module Grants
  class Supporter
      def self.grants
        {
          create: {
              name: 'Anlegen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :create, ::Supporter
                      end,
                      teacher: -> ability do
                        ability.can :create, ::Supporter
                      end
                  },
              }
          },
          read: {
              name: 'Anzeigen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :read, ::Supporter
                      end,
                      teacher: -> ability do
                        ability.can :read, ::Supporter
                      end
                  },
              }
          },
          update: {
              name: 'Bearbeiten',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :update, ::Supporter
                      end,
                      teacher: -> ability do
                        ability.can :update, ::Supporter
                      end

                  },
              }
          },
          destroy: {
              name: 'Löschen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :destroy, ::Supporter
                      end,
                      teacher: -> ability do
                        ability.can :destroy, ::Supporter
                      end
                  },
              }
          }
        }
      end
  end
end