class PortfolioSpecializationsGrid < BaseGrid

  scope do
    PortfolioSpecialization.all
  end

  filter(:name, :string, header: "Name") do |value|
    self.where(["portfolio_specializations.name LIKE ?",  "%#{value}%"])
  end
  filter(:abbreviation, :string, header: "Abkürzung")

  column(:name, header: "Name")
  column(:abbreviation, header: "Abkürzung")

  column(:actions,  header: '', style: 'width:100px', :html => true) do |i|
      "<div class='btn-group btn-group-nowrap btn-group-xs  pull-right' >
          <a href='#{edit_portfolio_specialization_path(i)}' role='button' class='btn btn-success btn-sm'>
            <i class='glyphicon glyphicon-pencil'></i>
          </a>
            #{ link_to  portfolio_specialization_path(i), data: {:confirm => 'Sicher?'},
             role: 'button', class: 'btn btn-danger btn-sm', :method => :delete do
             content_tag(:i, nil, class: 'glyphicon glyphicon-remove')
            end if i.can_be_deleted?  }
      </div>".html_safe
  end


end