class RemoteAdvancementPlansGrid < BaseGrid


  scope do
    CsbApi::AdvancementPlan.includes('advancement-plan-images')
  end

  def models
    locals = ::AdvancementPlan.where('catalog_id IN (?)', all_asset_ids ).index_by(&:catalog_id)
    models = []
    assets.all.each do |asset|
      if locals[asset.id].present?
        models <<  asset.populate_model(locals[asset.id])
      else
        models << asset.build_model
      end
    end
    models
  end

  filter(:search, header: "Beschreibung enthält",type: :string) do |value|
    self.where(search: value)
  end

  filter(:title, :string) do |value|
    self.where(title: value)
  end

  filter(:abbreviation, :string) do |value|
    self.where(abbreviation: value)
  end

  filter(:age_from_ge, header: "Altersbereich von",type: :integer) do |value|
    self.where(age_from_ge: value)
  end

  filter(:age_to_le,header: "bis",type: :integer) do |value|
    self.where(age_to_le: value)
  end

  column(:title, header: 'Titel', order: 'title')
  column(:abbreviation, header: 'Abk.', order: 'abbreviation')
  column(:year, header: 'Jahr', order: 'year')
  column(:age_from, header: 'Altersbereich', order: 'age_from')


end
