module Attachable
  extend ActiveSupport::Concern

  included do

    #--- Associations
    has_many :documents, as: :attachable, dependent: :destroy
    accepts_nested_attributes_for :documents, 
      allow_destroy: true, 
      reject_if: :is_optional_document
  end

  #--- public methods
  module ClassMethods
  end

  #--- private methods
  private

    def is_optional_document(attributes)

      # die Schweigepflichterklärung ist immer erforderlich
      return false if attributes[:category] == Document::categories.keys[Document::ENUM_CATEGORY_CONFIDENTIALITY_DOCUMENT]

      # wenn keine Datei hochgeladen wurde, können die Werte ignoriert werden
      if attributes[:file].nil?
        return true
      end

      false
    end

end