# Institutions documents are stored in tree structure, with child nodes referencing their parent by parent_id.
#
# This table can be used to QUERY ALL ANCESTOR INSTITUTION DOCUMENTS on path to the root:
# where(parent_id: 1).select(:child_id)
# returns all institution_document id in subtree of institution_document 1
#
# This table can also be used to QUERY ALL SUCCESSOR INSTITUTION DOCUMENTS inside subtree of an institution:
# where(child_id: 1).select(:parent_id)
# returns all nstitution_document in the path to root of institution_document 1
#
# this table is maintained by rdbms via triggers, so it is made readonly
# see db/migrate/20180119085729_add_folders_to_institution_documents.rb
#
class InstitutionDocumentHierarchy < ActiveRecord::Base
  after_initialize :readonly!
  belongs_to :parent, class_name: 'InstitutionDocument', foreign_key: :parent_id
  belongs_to :child, class_name: 'InstitutionDocument', foreign_key: :child_id
end
