# Institutions are stored in tree structure, with child nodes referencing their parent by parent_id.
#
# This table can be used to QUERY ALL ANCESTOR INSTITUTIONS on path to the root:
# where(parent_id: 1).select(:child_id)
# returns all institution id in subtree of institution 1
#
# This table can also be used to QUERY ALL SUCCESSOR INSTITUTIONS inside subtree of an institution:
# where(child_id: 1).select(:parent_id)
# returns all institution in the path to root of institution 1
#
# this table is maintained by rdbms via triggers, so it is made readonly
# see db/migrate/20170127091630_create_instituiton_hierarchies.rb
#
class InstitutionHierarchy < ActiveRecord::Base
  after_initialize :readonly!
end
