module Portfolio
  module Notifiers
    class RequiredStep  < Base
      attr_accessor :step
      attr_accessor :delay_display_sec
      attr_accessor :delay_due_after_display_sec


      def initialize
        @step = nil
        @delay_display_sec = 0
        @delay_due_after_display_sec = 0
      end

      def show?
        if portfolio.last_matching_item.nil?
          # sind die in der condition geforderten steps irgendwann schon erstellt worden?
          portfolio.portfolio_items.each do |following_item|
            return false if following_item.portfolio_step.name == step  # wenn ja, dann brauchen wir keine Notification,
          end
        else
          # sind die in der condition geforderten steps seit dem item, das die letzte regel aufgedeckt hat, erstellt worden?
          portfolio.portfolio_items.drop_while { |item| item.start <= portfolio.last_matching_item.start  }.each do |following_item|
            return false if following_item.portfolio_step.name == step  # wenn ja, dann brauchen wir keine Notification,
          end
        end
        return true
      end




    end
  end
end
