module SystemTasks
  module PortfolioRuleNotifications
    class RuleDescription < PortfolioRuleNotifications::Base

      class << self
        def do_create(notifier)
          create({
              target: notifier.portfolio,
              client: (notifier.portfolio.subject.is_a? Client) ? notifier.portfolio.subject : nil,
              institution: (notifier.portfolio.subject.is_a? ClientGroup) ? notifier.portfolio.subject_proxy.institution : nil,
              label: notifier.portfolio.subject_proxy.name,
              title:   "Massnahmen für #{ notifier.portfolio.subject_proxy.name}.",
              message:    notifier.rule.description,
              start_at:  DateTime.now,
              due_at:   DateTime.now,
              next_escalation:  DateTime.now,
              escalation_delay: 86400 * 14,
              resolve_location: notifier.portfolio.subject_proxy.resolve_notifications_path
          })
        end
      end

    end
  end
end