class TeacherCategory < ActiveRecord::Base

  #--- Associations
  has_many :teachers

  #--- Callback definitions
  before_destroy :is_destructable?

  validates :name, presence: true
  validates :is_special_ed, :is_support_teacher, inclusion: [true,false]

  def is_destructable?
    teachers.blank?
  end

end
