class DateValidator < ActiveModel::EachValidator
  def validate_each(record, attribute, value)
    value = record.public_send("#{attribute}_before_type_cast")
    if value.present? && ! value.is_a?(Date) && ((Date.parse(value) rescue ArgumentError) == ArgumentError)
      record.errors[attribute] << (options[:message] || "#{value} must be a valid datetime")
    end
  end
end
