module Portfolio
  class DocumentsIncludedValidator < ItemValidator

      attr_accessor :types

      # @param item ::Portfolio::Item
      def match?(item)
        return true unless @types
        @types.each do |t|
          if !item.portfolio.documents.reject(&:marked_for_destruction?).include?(t) # documents can be attached to all types of portfolio items
            return false
          end
        end
        return true
      end
  end
end