class RefactorCareerItems < ActiveRecord::Migration
  def change
    change_column :career_items, :start_at, :date, null: false # previously, null was allowed
    add_column :career_items, :teacher_name, :string # when reference is deleted, name is still there
    add_column :career_items, :client_group_name, :string # when reference is deleted, name is still there
    add_column :career_items, :institution_name, :string # when reference is deleted, name is still there
    remove_foreign_key :career_items, column: :client_id
    remove_foreign_key :career_items, column: :teacher_id
    remove_foreign_key :career_items, column: :client_group_id
    remove_foreign_key :career_items, column: :institution_id
    add_foreign_key :career_items, :clients, on_delete: :cascade # do not keep history for deleted client
    add_foreign_key :career_items, :teachers, on_delete: :nullify # keep history when teacher is deleted
    add_foreign_key :career_items, :client_groups, on_delete: :nullify # keep history when client_group is deleted
    add_foreign_key :career_items, :institutions, on_delete: :nullify # keep history when institution is deleted

  end
end