class DataMigrationPortfolioItemsRefactoring < ActiveRecord::Migration
  def up
    execute("UPDATE notifications SET notificationable_type='Portfolio::Item' where notificationable_type='PortfolioItem'")

    create_table :portfolios do |t|
      t.belongs_to :subject, polymorphic: true, index: true
      t.string :rule_set_id, index: true
      t.integer :portfolio_level
      t.date :rule_set_date
      t.timestamps
    end

    add_reference :portfolio_items ,:portfolio , index: true

    add_reference :clients, :running_portfolio, index: true

    ::Client.all.each do |c|
      portfolio = c.create_new_portfolio
      execute("UPDATE portfolio_items SET portfolio_id=#{portfolio.id}  where client_id=#{c.id}")
    end

    change_column_null :portfolio_items, :client_id, true

    # next up here

  end
  def down
    # next down here

    change_column_null :portfolio_items, :client_id, false

    ::Client.all.each do |c|
      execute("UPDATE portfolio_items SET client_id=#{c.id}  where portfolio_id=#{c.running_portfolio_id}")
    end

    remove_reference :clients, :running_portfolio

    remove_reference :portfolio_items, :portfolio

    drop_table :portfolios

    execute("UPDATE notifications SET notificationable_type='PortfolioItem' where notificationable_type='Portfolio::Item'")
  end
end
