class AddClassDiagnostics < ActiveRecord::Migration
  def change
    create_table :online_diagnostics do |t|
      t.string :title
      t.string :abbreviation
      t.integer :min_level
      t.integer :max_level
      t.string :description
      t.integer :remote_id
      t.integer :age_from
      t.integer :age_to
      t.timestamps
    end

    create_table :online_diagnostic_urls do |t|
      t.references :online_diagnostic
      t.string :name
      t.string :url
      t.timestamps
    end

    create_table :portfolio_item_class_diagnostics do |t|
      t.date :begin
      t.text :content
      t.references :diagnostic
      t.references :portfolio_item
      t.boolean :results_closed
      t.integer :age_from
      t.integer :age_to
      t.timestamps
    end

    create_table :portfolio_item_class_diagnostic_documents do |t|
      t.string :file_name
      t.references :portfolio_item_class_diagnostic
      t.timestamps
    end

  end
end
