class ChangeOnlineDiagnostics < ActiveRecord::Migration
  def up
    execute "ALTER TABLE online_diagnostics DROP CONSTRAINT online_diagnostics_pkey;"
    change_column(:online_diagnostics, :id, :string, null: false)
    execute "ALTER TABLE online_diagnostics ADD PRIMARY KEY (id);"
    execute "ALTER TABLE online_diagnostics ALTER id DROP DEFAULT;"

    change_column(:online_diagnostic_urls, :online_diagnostic_id, :string, null: false)
    execute "ALTER TABLE online_diagnostic_urls  ADD CONSTRAINT fk_odu_on_od_id FOREIGN KEY (online_diagnostic_id)  REFERENCES online_diagnostics (id) ON DELETE CASCADE ON UPDATE CASCADE;"
    execute "CREATE INDEX idx_odu_on_od_id ON online_diagnostic_urls(online_diagnostic_id);"

    change_column(:portfolio_item_class_diagnostics, :diagnostic_id, :string, null: false)
    execute "ALTER TABLE portfolio_item_class_diagnostics  ADD CONSTRAINT fk_picd_on_od_id FOREIGN KEY (diagnostic_id)  REFERENCES online_diagnostics (id) ON DELETE RESTRICT ON UPDATE CASCADE;"
    execute "CREATE INDEX idx_picd_on_od_id ON portfolio_item_class_diagnostics(diagnostic_id);"
  end

  def down
    execute "DROP INDEX idx_picd_on_od_id;"
    execute "ALTER TABLE portfolio_item_class_diagnostics  DROP CONSTRAINT fk_picd_on_od_id;"
    execute "ALTER TABLE portfolio_item_class_diagnostics ALTER COLUMN diagnostic_id TYPE integer USING diagnostic_id::integer;"
    execute "DROP INDEX idx_odu_on_od_id;"
    execute "ALTER TABLE online_diagnostic_urls DROP CONSTRAINT fk_odu_on_od_id;"
    execute "ALTER TABLE online_diagnostic_urls ALTER COLUMN online_diagnostic_id TYPE integer USING online_diagnostic_id::integer;"
    execute "ALTER TABLE online_diagnostics DROP CONSTRAINT online_diagnostics_pkey;"
    execute "ALTER TABLE online_diagnostics ALTER COLUMN id TYPE integer USING id::integer;"
    execute "ALTER TABLE online_diagnostics ADD PRIMARY KEY (id);"
    execute "ALTER TABLE online_diagnostics ALTER id SET DEFAULT nextval('online_diagnostics_id_seq'::regclass);"


  end
end
