class PortfolioRulesUseStringPk < ActiveRecord::Migration
  def up
    remove_foreign_key :portfolio_conditions, column: :rule_id
    remove_foreign_key :portfolio_conditions_steps, column: :step_id
    remove_foreign_key :portfolio_conditions_steps, column: :condition_id
    remove_foreign_key :portfolio_rule_steps, column: :rule_id
    remove_foreign_key :portfolio_rule_steps, column: :step_id
    remove_foreign_key :portfolio_step_results, column: :step_id
    remove_foreign_key :portfolio_items, column: :portfolio_step_id
    remove_foreign_key :portfolio_items, column: :portfolio_step_result_id
execute <<SQL
ALTER TABLE portfolio_conditions ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_conditions ALTER COLUMN rule_id SET DATA TYPE bigint;

ALTER TABLE portfolio_conditions_steps ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_conditions_steps ALTER COLUMN condition_id SET DATA TYPE bigint;
ALTER TABLE portfolio_conditions_steps ALTER COLUMN step_id SET DATA TYPE bigint;

ALTER TABLE portfolio_document_types ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_documents ALTER COLUMN portfolio_document_type_id SET DATA TYPE bigint;

ALTER TABLE portfolio_items ALTER COLUMN portfolio_step_id SET DATA TYPE bigint;
ALTER TABLE portfolio_items ALTER COLUMN portfolio_step_result_id SET DATA TYPE bigint;

ALTER TABLE portfolio_rule_steps ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_rule_steps ALTER COLUMN rule_id SET DATA TYPE bigint;
ALTER TABLE portfolio_rule_steps ALTER COLUMN step_id SET DATA TYPE bigint;

ALTER TABLE portfolio_rules ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_step_results ALTER COLUMN id SET DATA TYPE bigint;
ALTER TABLE portfolio_step_results ALTER COLUMN step_id SET DATA TYPE bigint;
ALTER TABLE portfolio_steps ALTER COLUMN id SET DATA TYPE bigint;

SQL
    add_foreign_key :portfolio_conditions, :portfolio_rules, column: :rule_id
    add_foreign_key :portfolio_conditions_steps, :portfolio_steps, column: :step_id
    add_foreign_key :portfolio_conditions_steps, :portfolio_conditions, column: :condition_id
    add_foreign_key :portfolio_rule_steps,:portfolio_rules, column: :rule_id
    add_foreign_key :portfolio_rule_steps,:portfolio_steps, column: :step_id
    add_foreign_key :portfolio_step_results,:portfolio_steps, column: :step_id
    add_foreign_key :portfolio_items,:portfolio_steps, column: :portfolio_step_id
    add_foreign_key :portfolio_items,:portfolio_step_results, column: :portfolio_step_result_id
  end

  def down
    remove_foreign_key :portfolio_conditions, column: :rule_id
    remove_foreign_key :portfolio_conditions_steps, column: :step_id
    remove_foreign_key :portfolio_conditions_steps, column: :condition_id
    remove_foreign_key :portfolio_rule_steps, column: :rule_id
    remove_foreign_key :portfolio_rule_steps, column: :step_id
    remove_foreign_key :portfolio_step_results, column: :step_id
    remove_foreign_key :portfolio_items, column: :portfolio_step_id
    remove_foreign_key :portfolio_items, column: :portfolio_step_result_id
    execute <<SQL
ALTER TABLE portfolio_conditions ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_conditions ALTER COLUMN rule_id SET DATA TYPE integer USING rule_id::integer;

ALTER TABLE portfolio_conditions_steps ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_conditions_steps ALTER COLUMN condition_id SET DATA TYPE integer USING condition_id::integer;
ALTER TABLE portfolio_conditions_steps ALTER COLUMN step_id SET DATA TYPE integer USING step_id::integer;

ALTER TABLE portfolio_document_types ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_documents ALTER COLUMN portfolio_document_type_id SET DATA TYPE integer USING portfolio_document_type_id::integer;

ALTER TABLE portfolio_items ALTER COLUMN portfolio_step_id SET DATA TYPE integer USING portfolio_step_id::integer;
ALTER TABLE portfolio_items ALTER COLUMN portfolio_step_result_id SET DATA TYPE integer USING portfolio_step_result_id::integer;

ALTER TABLE portfolio_rule_steps ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_rule_steps ALTER COLUMN rule_id SET DATA TYPE integer USING rule_id::integer;
ALTER TABLE portfolio_rule_steps ALTER COLUMN step_id SET DATA TYPE integer USING step_id::integer;

ALTER TABLE portfolio_rules ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_step_results ALTER COLUMN id SET DATA TYPE integer USING id::integer;
ALTER TABLE portfolio_step_results ALTER COLUMN step_id SET DATA TYPE integer USING step_id::integer;
ALTER TABLE portfolio_steps ALTER COLUMN id SET DATA TYPE integer USING id::integer;

SQL
    add_foreign_key :portfolio_conditions, :portfolio_rules, column: :rule_id
    add_foreign_key :portfolio_conditions_steps, :portfolio_steps, column: :step_id
    add_foreign_key :portfolio_conditions_steps, :portfolio_conditions, column: :condition_id
    add_foreign_key :portfolio_rule_steps,:portfolio_rules, column: :rule_id
    add_foreign_key :portfolio_rule_steps,:portfolio_steps, column: :step_id
    add_foreign_key :portfolio_step_results,:portfolio_steps, column: :step_id
    add_foreign_key :portfolio_items,:portfolio_steps, column: :portfolio_step_id
    add_foreign_key :portfolio_items,:portfolio_step_results, column: :portfolio_step_result_id
  end
end
